#ifndef SCANCONTROLLER_H
#define SCANCONTROLLER_H

#include "mainwindow.h"
#include "vzconfig.h"

#include <riegl/ctrllib.hpp>
#include <riegl/scanlib.hpp>
#include <QObject>
#include <QLabel>
#include <QPlainTextEdit>

class VZConfig;
class MainWindow;

class ScanController : public QObject
{
	Q_OBJECT
	//############################################
	//#####  Controller Functions  ###############
	//############################################
public:
	ScanController(MainWindow* parent);
	~ScanController();
	bool checkBusy(bool wait);
	int camCheck();
//	int retrieveConfig(VZConfig* config);

private:
	int exposureIndexValidate(int i);

	//############################################
	//#####  Controller Functions  ###############
	//############################################
public slots:
	void camStart();
	void camFinalize(bool success);
	void scanStart();
	void sessionExit(bool success);
	void scanFinalize(bool success);

signals:
	void sessionFinished(bool);
	void scanningStarted();
	void cameraStarted(int);

	//############################################
	//#####  Controller Variables  ###############
	//############################################
public:
	QString		VZ_ScannerAddress;
	QString		VZ_ScanName;
	QString		VZ_ScanPath;
	float		VZ_Roll, VZ_Pitch;
	int			VZ_TimeEstimate;

protected:
	// declare and construct client session
	// Note: no connection to the instrument is opened yet
	ctrllib::ctrl_client_session session;

private:
	MainWindow* mainwin;
	VZConfig* config;

	QList<float> exposureList;
	float hstartActual;
	float hstopActual;

	enum scanmsgs{
		MSG_INFO,
		MSG_WARNING,
		MSG_ERROR,
		MSG_SERIOUSERROR,
		MSG_FATALERROR
	};
};

#endif // SCANCONTROLLER_H
